var selectedSection = "webforms";
var selectedEntry = null;
var selectedFolder = "";
var total_items = 0;
var current_sort_criteria = "Name";
var current_sort_ascending = true;
var entries = [];
var currentEntry = null;
var concealedFieldCount = 0;

function profileContentsDidFinishLoading(json) {
	if (!json || json == "") {
		alert("Could not find contents.js. Please try again.");
	}
	
	var allItems = eval(json);
	keychain.setContents(allItems);
	
	renderSectionList();
	selectSection(TYPE_WEBFORMS)
}

function renderSectionList() {
	var h = "";
	h += renderSectionListItem(TYPE_WEBFORMS, "Logins", "logins-20.png");
	h += renderSectionListItem(TYPE_IDENTITIES, "Identities", "identities-20.png");
	h += renderSectionListItem(TYPE_NOTES, "Secure Notes", "secure-notes-20.png");
	h += renderSectionListItem(TYPE_SOFTWARE_LICENSES, "Software", "software-20.png");
	h += renderSectionListItem(TYPE_WALLET, "Wallet", "wallet-20.png");
	h += renderSectionListItem(TYPE_PASSWORDS, "Passwords", "passwords-20.png");
	h += renderSectionListItem(TYPE_TRASHED, "Trash", "trash-20.png");
	$('sourcesPane').innerHTML = h;
}

function renderSectionListItem(name, displayName, img) {
	var r = "<li " + sectionOptions(name) + ">";
	r += "<img  src='./style/images/" + img + "' alt='' />" + displayName;
	r += sectionCount(name, displayName);
	r += "</li>";
	return r;
}

function sectionOptions(name) {
	var opts = "id='" + name + "' onclick='selectSection(\"" + name + "\")'"
	
	if (selectedSection == name) {
		opts += " class='selected' "
	}
	return opts;
}

function sectionCount(name, display_name) {
	var result = " <span class='sectionCount'>(" + keychain.itemsOfType(name).length + ")</span>";
	return result;
}

function selectFolder(el) {
	$('sections').setAttribute('class', 'inactivePane');
	$('folders').setAttribute('class', '');
	var oldSelectedSection = selectedSection;
	selectedSection = "";
	styleSection(oldSelectedSection);
	
	if (selectedFolder != "") $(selectedFolder).setAttribute("class", "");
	el.parentNode.setAttribute("class", "selectedFolder");
	selectedFolder = el.parentNode.id;
	
	loadSection(selectedFolder);
}

function toggleSubfolder(el) {
	var id = el.parentNode.id.substring(7);
	
	if ($('subfolder-'+id).style.display == '') {
		$('subfolder-'+id).style.display = 'none';
		el.setAttribute('class', 'folderArrowClosed');
	}
	else {
		$('subfolder-'+id).style.display = '';
		el.setAttribute('class', 'folderArrowOpen');
	}
}

function showAndHideConcealedField(id, clearText, concealed) {
	var revealHide = concealed ? "Reveal" : "Hide";

	// IMPL NOTE: Normally you need not escape HTML values in JS, but innerHTML assignment interprets the JS for some reason.
	// Note the use &apos instead of '. This is important as the interpreter gets confused when evaling innerHTML.
	var htmlValue = clearText.escapeHTML();
	var jsValue = htmlValue.gsub(/\\/, "\\\\");
	jsValue = jsValue.gsub(/"/, "\\\"").gsub(/'/, "&apos;");

// Remove copy button for now. Potential fix here:
// http://cfruss.blogspot.com/2009/01/copy-to-clipboard-swf-button-cross.html

	var r = "<span class='hideRevealButton' id='" + id + "'><a class='copy'>";	
//flash10	r += "<a class='copy' href='#' id='" + id + "-value'>";
	r += concealed ? concealedField() : htmlValue;
//flash10	r += "<span class='copyButton' onclick='copy_to_clipboard(\"" + jsValue + "\")'>Copy</span>";
//flash10	r += "</a>";

	r += "<a class='revealButton' href='#' style='text-decoration:none' onclick='showAndHideConcealedField(\"" + id + "\", \"" + jsValue + "\", " + !concealed + ")'>" + revealHide + "</a>";
	
	r += "</a></span>"

	if ($(id)) $(id).innerHTML = r;
 	
	return r;
}

function concealedField() {
	var r = ""; 
	for (var i=0; i < 10; i++) {
		r += "&bull;";
	}
	return r;
}

function showPassword(data)
{
	if (data.notesPlain && data.notesPlain.length > 0) {
		$('entryNotesDecryptedValue').innerHTML = '<p>' + convertNewLines(data.notesPlain.escapeHTML()) + '</p>';
		$('entryNotesDecryptedValue').parentNode.style.display = "";
	}
	
	var passwd = "<tr><td class='fieldName'>Password</td><td class='fieldValue'>" + data.password.escapeHTML() + "</td></tr>";
	$('dynamicFields').innerHTML = passwd;
}

function convertNewLines(txt) {
	return txt.gsub("\n\r", "\n").gsub("\r\n", "\n").gsub("\r", "\n").gsub("\n", "<br/>");
}

function sortBy(criteria) {
	keychain.rescheduleAutoLogout();
	if (criteria == current_sort_criteria) {
		current_sort_ascending = !current_sort_ascending;
	}
	else {
		current_sort_criteria = criteria;
	}
	
	displayEntries();
}

function updateEntryListHeader(name) {
	var header = $('listHeader' + name);
	var sort_img = header.childNodes[0].childNodes[0];
	
	if (name == current_sort_criteria) {
		header.setAttribute("class", "selectedHeader");
		sort_img.style.display = "";
		var img = "./style/images/interface/table_arrow_";
		if (current_sort_ascending) img += "down.png"
		else img += "up.png";
		
		sort_img.src = img;
	}
	else {
		header.setAttribute("class", "normalHeader");
		sort_img.style.display = "none";
	}
}

function updateEntryListHeaders() {
	updateEntryListHeader("Name");
	updateEntryListHeader("Domain");
	updateEntryListHeader("Modified");
}

function sortCompareFunction(a, b) {
	if (current_sort_criteria == "Domain") {
		a = a.domain;
		b = b.domain;
	}
	else if (current_sort_criteria == "Modified") {
		a = a.updatedAtMs + "";
		b = b.updatedAtMs + "";
	}
	else {
		a = a.title;
		b = b.title;
	}
	
	var result = 0;
    if ( a.toLowerCase() < b.toLowerCase() ) {
		result = -1;
    }
    else if ( a.toLowerCase() > b.toLowerCase() ) {
		result = 1;
    }

	if (!current_sort_ascending) result = result * -1;
	
	return result;
}

function styleSectionCount(id)
{
	var current_count = $(id + "-count");
	if (!current_count) return;

	var color = "gray";
	var clazz = "itemNumberTotal";
    
	if (id == selectedSection) {
		color = "white"
		clazz = "itemNumberTotalSelected"
    }

	var children = current_count.childNodes;
	children[1].src = "/images/sections/item_number_right_" + color + ".png";
	children[3].setAttribute("class", clazz);
	children[5].src = "/images/sections/item_number_left_" + color + ".png";
}

function styleSection(id) {
	if (id == "" || id.indexOf("folder") == 0) return;
	
	if (id == selectedSection) {
		$(id).className = "selectedSection";
		$(id).childNodes[1].className = "sectionLinkSelected";
	}
	else {
		$(id).className = "";
		$(id).childNodes[1].className = "sectionLink";
	}
	styleSectionCount(id);
}

function selectSection(section_id)
{
	if (selectedFolder != "") $(selectedFolder).setAttribute('class', '');
	
	keychain.rescheduleAutoLogout();
	
	if (selectedSection != section_id)
	{
		selectedSection = section_id;
		renderSectionList();
		displayEntries({'select_first':true});
	}
}

function selectEntry(entry_id)
{
	keychain.rescheduleAutoLogout();
	selectedEntryId = entry_id;
	
	// Deselect the currently highlighted entry
	var highlighted = $$('#listPane .selected');
	for (var i=0; i < highlighted.length; i++) {
		highlighted[i].removeClassName('selected');
	}
	
	$('entry_' + entry_id).addClassName('selected');
	var file = fullKeychainFilePath(entry_id + ".1password");
	loadFile(file, entryDidFinishLoading);
}

function entryDidFinishLoading(json) {
	if (!json || json == "") {
		alert("The data file for this entry could not be loaded.")
		return;
	}
	
	var entry;
	try {
		var json = "(" + json + ")";
		entry = eval(json);
	}
	catch (e) {alert('Error evaluating data for this entry! Error: ' + e);}
	
	selectedEntry = new KeychainItem(entry);
	showEntryDetails();
}

function displayEntries(opts)
{
	var select_first = false;
	if (opts) {
		select_first = opts['select_first']
	}
	
	var entries = keychain.itemsOfType(selectedSection);
	keychain.rescheduleAutoLogout();
	
	entries.sort(sortCompareFunction);
	var i, len = entries.length;
	var displayCount = 0;
	var html = ""
	for (i = 0; i < len; ++i) {
		e = entries[i];
		
		displayCount++;
		var title = e.title;
		var domain = e.domain;
		var date = e.updatedAt;
		var uuid = e.uuid;
		var clazz = "";
		
		html += '<li id="entry_' + uuid + '" onclick="selectEntry(\''+uuid+'\')"><strong>'+title.escapeHTML()+'</strong><br/>'+domain+'</li>';
	}
	$('listPane').innerHTML = html;
	
	if (select_first) selectEntry(entries[0].uuid);
}

function showEntryDetails() {
	keychain.rescheduleAutoLogout();
	$('emptyDetailsPane').style.display = "none";
	$('detailsPane').style.display = "";
	
	concealedFieldCount = 0;
	
	var decryption_status;
	try { decryption_status = selectedEntry.decrypt() } 
	catch (e) {alert("error " + e);}
	
	if (decryption_status != ERROR_OK) {
		alert("An error occurred while processing item '" + selectedEntry.uuid + "'.\n\n" + decryption_status );
		return;
	}
	
	$('detailsPane').innerHTML = "";
	$('detailsPane').innerHTML = selectedEntry.asHTML();
}

function clearEntryDetails() {
	$('listPane').innerHTML = "";
	$('sourcesPane').innerHTML = "";
	$('detailsPane').innerHTML = "";
}

function searchEntries()
{
	keychain.rescheduleAutoLogout();
	var s = $("search").value.toLowerCase();
	entries = [];
	
	if (s.length > 0) {
		$('clearSearch').style.display = "";
	}
	else {
		$('clearSearch').style.display = "none";
	}
	
	var i, len = allEntries.length - 1;
	for (i=0; i<len; ++i) {
		var e = allEntries[i];
		
		if (e[1].toLowerCase().indexOf(s) >= 0 || e[2].toLowerCase().indexOf(s) >= 0)
			entries.push(e);
	}
	
	displayEntries();

	// Reset selected entry if need be
	if (selectedEntryId) {
		if ($("entry_" + selectedEntryId)) {
			$("entry_" + selectedEntryId).setAttribute("class", "selectedRow");
		}
		else {
			selectedEntryId = null;
		}
	}
}

function clearSearch() {
	$("search").value = "";
	$("search").focus();
	searchEntries();
}

function onClientLoad()
{
	$('loadingHUD').style.display = "";
	loadSection(selectedSection);
	updateLockStatus();
	keychain.rescheduleAutoLogout();
	$("search").value = ""; // Sometimes reload does not clear the search criteria 

	document.onkeydown = handleHotkeys;
	
	if (selectedSection.indexOf('folder-') == 0) {
		selectedFolder = selectedSection;
		selectFolder($(selectedFolder).childNodes[0]);
	}
	else {
		selectSection(selectedSection);
	}
}

function handleHotkeys(e)
{
	if (!e) e = window.event;
	var key = String.fromCharCode(e['keyCode']);
	
	if (e['ctrlKey']) {
		if (key == 'F') {
			$("search").focus();
		}
	}
}
